SystemOrganization addCategory: #SWA014!

Morph subclass: #SWA014Game
	instanceVariableNames: 'world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'M.V. 11/30/2016 23:15'!
open
	^self new spawnPlayer; spawnEnemy; openInWorld; yourself.
	! !

!SWA014Game methodsFor: 'deleting' stamp: 'M.V. 11/30/2016 22:56'!
destroyAllEntities
	self flag: 'TODO: delete this method; this method only helps us controlling all objects, we do not need anymore for tests'.
	
	self swaworld listOfEnemies do: 
	[:x| x delete].
	self swaworld listOfEnemies: Set new.

	self swaworld swaplayer delete.
	self swaworld swaplayer: nil.
	
	self swaworld delete.
	self swaworld: nil.! !

!SWA014Game methodsFor: 'game events' stamp: 'M.V. 11/30/2016 23:51'!
gameOver
	self destroyAllEntities.
	self delete.! !

!SWA014Game methodsFor: 'initialization' stamp: 'M.V. 11/30/2016 23:50'!
initialize
	super initialize.
	
	self swaworld: SWA014World new.
	self addMorph: self swaworld.
	self swaworld game: self.
	
	self clipSubmorphs: true.
	self extent: (World bounds corner x)@(World bounds corner y). "ActiveWorld extent"! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/2/2016 14:36'!
spawnEnemy
"spawns SWA014Enemys up to the specified number"
|enemy random r1 r2 r3 MAXSIZE NUMBER_OF_ENEMIES|
MAXSIZE := 75.
NUMBER_OF_ENEMIES := 15.

1 to: NUMBER_OF_ENEMIES  do:
[:x|	
	enemy := SWA014Enemy new openInWorld.
	random := Random new.
	r1 := random nextInt: self swaworld width.
	r2 := random nextInt: self swaworld height.
	r3 := random nextInt: MAXSIZE.
	enemy realCenter: (r1@r2).
	enemy center: enemy realCenter.
	enemy bodysize: r3.	
	enemy swaworld: self swaworld.
	self swaworld listOfEnemies add: enemy.
	self swaworld addMorph: enemy.
].! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/2/2016 14:40'!
spawnPlayer
	|newPlayer|
	newPlayer := SWA014Player new openInWorld.
	newPlayer color: Color red.
	newPlayer bodysize: 50.
	newPlayer realCenter: self swaworld realCenter.
	newPlayer center: newPlayer realCenter.
	newPlayer swaworld: self swaworld.		
	self swaworld swaplayer: newPlayer.
	self addMorph: newPlayer.
	! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 11/11/2016 14:35'!
spawnPowerup
self flag: 'TODO: implement; this is an extension and shouldn''t be implemented until the basic game works'.! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld
	^world.! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld: x
	world := x.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'bodysize speed id direction world currentStep realCenter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'movement' stamp: 'MV 12/2/2016 12:35'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."

calculateMovement: target
	super calculateMovement: target realCenter.
	
	target bodysize >= self bodysize
	ifTrue:
	 [
		self direction: (0@0) - self direction.
	].
	! !

!SWA014Enemy methodsFor: 'vision' stamp: 'MV 12/2/2016 14:34'!
nearestEnemy
	|smallestDistance nearestEnemyobject allEnemies currentDistance BIGNUMBER|
	
	BIGNUMBER := SmallInteger maxVal.
	smallestDistance := BIGNUMBER.
	nearestEnemyobject := self.
	
	allEnemies := Set new.
	allEnemies := self swaworld listOfEnemies copy.
	allEnemies add: self swaworld swaplayer.
	
	allEnemies do: 
	[:enemy| 
	currentDistance := self distanceTo: enemy realCenter.
	(currentDistance  < smallestDistance)
	ifTrue: [smallestDistance := currentDistance.
			nearestEnemyobject := enemy.]
	] without: self.

	^nearestEnemyobject.! !

!SWA014Enemy methodsFor: 'override' stamp: 'MV 12/2/2016 12:16'!
step
	self currentStep > self stepNumber
	ifTrue:
	[
		self calculateMovement: self nearestEnemy.
		self moveAutomatically.
		self currentStep: 0.
	] 
	ifFalse:
	[
		self currentStep: self currentStep + 1.
	].
	
	super step.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 22:59'!
bodysize 
	^bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 23:00'!
bodysize: x
	|MAX_ALLOWED_SIZE MIN_ALLOWED_SIZE|
	
	MAX_ALLOWED_SIZE := 1000.
	MIN_ALLOWED_SIZE := 10.
	
	x < MAX_ALLOWED_SIZE
	ifTrue: 
	[
		x > MIN_ALLOWED_SIZE
		ifTrue: 
		[
			bodysize := x.
		]
		ifFalse: 
		[
			bodysize := MIN_ALLOWED_SIZE.
		].		
	]
	ifFalse:
	[
		bodysize := MAX_ALLOWED_SIZE.
	] .
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/2/2016 12:35'!
calculateMovement: target
	|directionVector deltaX deltaY distance|
		
	deltaX := (target x - self realCenter x).
	deltaY := (target y - self realCenter y).
	
	distance := self distanceTo: target.
	distance = 0 ifTrue: [distance := 1.]. "prevent us from dividing by zero"
	directionVector := ((deltaX/distance)@(deltaY/distance)).
	self direction: directionVector.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 12/1/2016 11:26'!
checkForCollisions
	|radius listOfLivingThings|
	
	radius := self bodysize/2.	
	listOfLivingThings := Set new.
	listOfLivingThings := self swaworld listOfEnemies copy.
	listOfLivingThings add: self swaworld swaplayer.
	
	listOfLivingThings do:
	[	
		:enemy|
		(enemy ~~ self) ifTrue: 
		[
			(enemy bodysize < self bodysize) ifTrue: 
			[
				((self distanceTo: enemy realCenter) < radius) ifTrue: 
				[
					self eat: enemy.
				]
			]
		]
	]! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:53'!
currentStep
	^currentStep.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:52'!
currentStep: x
	currentStep := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/2/2016 14:35'!
direction: x
Transcript showln: x.
"self haltIf: [x= (0@0)]."
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 12/2/2016 12:36'!
distanceTo: enemy
	^(((enemy x - self realCenter x) raisedTo: 2)+
	((enemy y - self realCenter y) raisedTo: 2)) sqrt. "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'M.V. 11/30/2016 23:17'!
eat: prey
	self bodysize: 2* (((self bodysize / 2) raisedTo: 2) + ((prey bodysize / 2) raisedTo: 2)) sqrt.

	self swaworld listOfEnemies: 
		(self swaworld listOfEnemies reject: [:enemy| enemy == prey]).
	(prey ~~ self swaworld swaplayer) 
	ifTrue: 
	[
		prey delete.
	]
	ifFalse: 
	[
		self swaworld game gameOver.
	].! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'MV 12/1/2016 11:18'!
initialize
	super initialize.
	self currentStep: 0.
	self speed: 60.
	self direction: (0@0).
	self realCenter: self center.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/1/2016 11:12'!
moveAutomatically
	self realCenter: self realCenter + (2* self direction).
	self center: self realCenter.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'MV 12/1/2016 11:09'!
realCenter
	^realCenter.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'MV 12/1/2016 11:09'!
realCenter: x
	realCenter := x.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 23:17'!
refreshSize
	self extent: self bodysize asPoint.
	
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/24/2016 15:02'!
speed: x
	|MAX_ALLOWED_SPEED MIN_ALLOWED_SPEED|
	
	MAX_ALLOWED_SPEED := 1000.
	MIN_ALLOWED_SPEED := 1.
	
	x < MAX_ALLOWED_SPEED
	ifTrue: 
	[
		x> MIN_ALLOWED_SPEED
		ifTrue: 
		[
			 speed := x.
		]
	 	ifFalse:
		[
			speed := MIN_ALLOWED_SPEED.
		].
	]
	ifFalse:
	[
		speed := MAX_ALLOWED_SPEED.
	] .
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'M.V. 11/18/2016 14:19'!
step
	self checkForCollisions.
	self refreshSize.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 12/2/2016 14:44'!
stepNumber
	"This is used to keep the stepTime up to date"
	
	self speed ~= 0
	ifTrue:
	[
		^5 * (self bodysize)  / self speed.	
	]
	ifFalse: 
	[
		^SmallInteger maxVal.	"Stops stepping"
	].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'M.V. 11/18/2016 14:38'!
stepTime
	^1! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld
	^world.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld: x
	world := x.! !

SWA014LivingThing subclass: #SWA014Player
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Player commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Player methodsFor: 'movement' stamp: 'MV 12/2/2016 14:41'!
moveAutomatically
	self swaworld realCenter: self swaworld realCenter - self direction.
	self swaworld center: self swaworld realCenter.

	"self realCenter: self realCenter + self direction.
	self center: self realCenter."! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:42'!
number
	^number.! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:41'!
number: x
	number := x.! !

!SWA014Player methodsFor: 'override' stamp: 'M.V. 11/25/2016 11:16'!
step
	super step.
	self calculateMovement: World activeHand center.
	self moveAutomatically.! !

ImageMorph subclass: #SWA014World
	instanceVariableNames: 'worldSize listOfEnemies swaplayer game realCenter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'initialization' stamp: 'MV 12/1/2016 11:19'!
initialize
	|aForm|
	super initialize.
	aForm := ImageReadWriter formFromFileNamed: 'raster.jpg'.
	self newForm: aForm.
	self listOfEnemies: Set new.
	self swaplayer: nil.
	self worldSize: 3000.
	self extent: self worldSize asPoint.
	self realCenter: (World bounds corner x / 2)@(World bounds corner y / 2).
	self center: self realCenter.
	self openInWorld.
	self color: Color transparent.
	self clipSubmorphs: true.
	
	
! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies
	^ listOfEnemies! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies: anObject
	listOfEnemies := anObject! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/1/2016 11:10'!
realCenter
	^realCenter.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/1/2016 11:10'!
realCenter: x
	realCenter := x.! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/30/2016 22:55'!
swaplayer
	^swaplayer.! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/30/2016 22:55'!
swaplayer: x
	swaplayer := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'Tc 11/30/2016 20:31'!
worldSize
	^worldSize! !

!SWA014World methodsFor: 'accessing' stamp: 'Tc 11/30/2016 20:32'!
worldSize: anObject
	worldSize := anObject! !
